class JitDurPredictor(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  device : Device
  dur_class_type : NoneType
  log_dur : bool
  speaker_emb : str
  dur_pred : __torch__.jit_forward_model.___torch_mangle_134.TransformerSeriesPredictor
  def forward(self: __torch__.jit_forward_model.___torch_mangle_135.JitDurPredictor,
    text: Tensor,
    speaker_ids: Tensor,
    orig_mask: Tensor,
    alpha: float=1.) -> Tensor:
    dur_pred = self.dur_pred
    dur_hat = (dur_pred).forward(text, speaker_ids, orig_mask, alpha, )
    return torch.squeeze(dur_hat, -1)
